<script lang="ts">
import Vue from 'vue';
import { MetaInfo } from 'vue-meta/types/vue-meta';
import {
  Hero,
  Highlights,
  LearnMore,
  Quote,
  Showcase,
} from '../components/environmental-social-governance/index.vue';
import { NextStepAlt } from '~/components/common/index.vue';
import { getPageMetadata } from '~/common/meta';
import { ContentfulLivePreview } from '@contentful/live-preview';
import { LivePreviewMixin } from '~/mixins';

export default Vue.extend({
  components: {
    Hero,
    Quote,
    Highlights,
    Showcase,
    LearnMore,
    NextStepAlt,
  },
  mixins: [LivePreviewMixin],
  async asyncData({ $environmentalSocialGovernanceService }: any) {
    try {
      const { esg, items } =
        await $environmentalSocialGovernanceService.getContent();
      return { esg, items };
    } catch (e) {
      throw new Error(e);
    }
  },
  head(): MetaInfo {
    return getPageMetadata(
      (this as any).esg,
      this.$route.path,
      this.$nuxtI18nHead({ addSeoAttributes: true }),
    );
  },
  mounted() {
    if (this.isPreview) {
      const unsubscribeFn = ContentfulLivePreview.subscribe({
        data: this.items,
        callback: async (updatedData) =>
          (this.esg =
            await this.$environmentalSocialGovernanceService.transformContentfulData(
              updatedData,
            )),
      });
      this.livePreviewSubscriptions.push(unsubscribeFn);
    }
  },
});
</script>

<template>
  <div id="esg-wrapper">
    <Hero v-if="esg.hero" v-bind="esg.hero" />
    <Quote v-if="esg.letter" v-bind="esg.letter" />
    <Highlights v-if="esg.highlights" v-bind="esg.highlights" />
    <Showcase
      v-if="esg.showcase"
      v-bind="esg.showcase"
      class="esg-wrapper__body"
    />
    <SlpContainer v-if="esg.learn_more">
      <LearnMore v-bind="esg.learn_more" />
    </SlpContainer>
    <NextStepAlt />
  </div>
</template>
<style lang="scss" scoped>
#esg-wrapper {
  overflow-x: clip;
  position: relative;
  &:before {
    content: '';
    position: absolute;
    width: 100%;
    height: 100%;
    top: 0;
    right: 0;
    background-image: url('/nuxt-images/customers/esg-texture.png');
    background-repeat: no-repeat;
    background-position: 0 20%;
    pointer-events: none;
    @media (min-width: $breakpoint-md) {
      width: 58%;
      background-position: top right;
      background-size: 100% auto;
    }
    @media (min-width: 2000px) {
      width: 60%;
      max-height: 2000px;
      background-size: initial;
    }
  }
  > *,
  div {
    position: relative;
  }
  :deep {
    #side-nav-parent {
      position: relative;
    }
  }
}
.esg-wrapper__body {
  background: $color-surface-800;
  position: relative;
  padding-bottom: 64px;
  margin-top: 120px;
  &:before {
    background: $color-surface-800;
    content: '';
    position: absolute;
    width: 100vw;
    height: 100%;
    left: 50%;
    transform: translateX(-50%);
  }
}
</style>
